Allow user to choose whether to print finite field elems as symm residues or non-neg residue

13 Jan 2022 12:57 - John Abbott

Status: In Progress Start date: 13 Jan 2022

Priority: Normal Due date:  

Assignee:  % Done: 10%

Category: CoCoA-5 function: new Estimated time: 0.00 hour

Target version: CoCoA-5.4.2 Spent time: 0.85 hour

Description

A student here asked how to make CoCoA-5 print elements of a finite field as the least non-neg residue class representative.

CoCoALib allows this, but CoCoA-5 does not.

History

#1 - 13 Jan 2022 12:58 - John Abbott

JAA thinks that allowing the user to choose should not cause any problems: it is just a matter of printing.

Mmm, well, what should AsINT produce?

#2 - 13 Jan 2022 13:07 - John Abbott

The current impl in SmallFpImpl.H  expects there to be a boolean data mem which says how to print (LeastNonNeg or Symm).

The choice is fixed at creation time of the ring.  The flag affects only the mem fn myExport.

Do we want to allow a global variable which is consulted each time a value is exported?

Maybe we need a 3-way flag: LeastNonNeg, Symm, UseGlobalSetting ?

SOURCE: Consult source code in SmallFpImpl.H

#3 - 20 Jan 2022 19:02 - John Abbott

I have just given a demo to my students of using CRT to reconstruct a large integer value.

The demo happened to work well because AsINT returns "symmetric" representatives when

applied to elements of a finite field.  Naturally, it did not work do well when I used the

prime 2.  Technically this is my fault (since I should have checked what AsINT does).

Maybe there should be 2 fns instead of (or as well as?) AsINT for elements of a finite field.

For instance: SymmRepr  and LeastNonNegRepr.

#4 - 21 Jan 2022 10:27 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

Anna suggests these names: AsINT_Symm and AsINT_NonNeg  (because AsINT_LeastNonNeg is too long)
The idea is to have a name "similar" to AsINT.

UPDATE  AsINT_symm and AsINT_NonNeg would give error if applied to an element of a ring of char 0... right?

#5 - 27 Jan 2022 14:52 - John Abbott

The idea seems reasonable, but what names should we use?

AsINT_symm  or AsINT_Symm

AsINT_NonNeg or AsINT_nonneg or AsINT_nneg

Other suggestions?

#6 - 03 Feb 2022 19:15 - John Abbott

- Target version changed from CoCoA-5.4.0 to CoCoA-5.4.2
